package com.jiuqi.util;

import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.lang.management.ManagementFactory;
import java.lang.management.RuntimeMXBean;

public class ProcessUtils
{
    private static RuntimeMXBean runtimeMXBean;
    
    static {
        ProcessUtils.runtimeMXBean = null;
    }
    
    private static RuntimeMXBean getRuntimeMXBean() {
        if (ProcessUtils.runtimeMXBean == null) {
            ProcessUtils.runtimeMXBean = ManagementFactory.getRuntimeMXBean();
        }
        return ProcessUtils.runtimeMXBean;
    }
    
    public static String getCurrentProcessName() {
        final RuntimeMXBean rtb = getRuntimeMXBean();
        return rtb.getName();
    }
    
    public static int getCurrentProcessID() {
        final String processName = getCurrentProcessName();
        int pid = -1;
        final Pattern pattern = Pattern.compile("^([0-9]+)@.+$", 2);
        final Matcher matcher = pattern.matcher(processName);
        if (matcher.matches()) {
            pid = Integer.parseInt(matcher.group(1));
        }
        return pid;
    }
}
